-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["MAGE"] = {}
lib.classes["MAGE"][1] = function ()
	lib.AddSpell("ab",{30451}) -- Arcane Blast
	lib.AddSpell("am",{5143}) -- Arcane Missiles
	lib.AddSpell("aba",{44425}) -- Arcane Barrage
	lib.AddSpell("ma",{6117}) -- Mage Armor
	lib.AddSpell("ap",{12042}) -- Arcane Power
	
	lib.AddAura("ab",36032,"debuff","player") -- Arcane Blast
	lib.AddAura("am",79683,"buff","player") -- Arcane Missiles!
	lib.AddAura("ma",6117,"buff","player") -- Mage Armor
	lib.AddAura("apot",31572,"buff","player") -- Arcane Potency
	lib.AddAura("ap",12042,"buff","player") -- Arcane Power
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"ma")
	table.insert(cfg.plistdps,"ab_ap")
	table.insert(cfg.plistdps,"ab_apot")
	table.insert(cfg.plistdps,"am")
	table.insert(cfg.plistdps,"aba")
	table.insert(cfg.plistdps,"ab")
	table.insert(cfg.plistdps,"end")
	
	cfg.plist=cfg.plistdps
	
	cfg.case = {
		["ab_ap"] = function ()
			local t = lib.GetAura({"ap"})
			if t>0 then
				return lib.SimpleCDCheck("ab")
			end
			return nil
		end,
		["ab_apot"] = function ()
			local t,n = lib.GetAura({"apot"})
			if n==2 or (n==1 and not lib.SpellCasting("ab")) then
				return lib.SimpleCDCheck("ab")
			end
			return nil
		end,
		["ab"] = function ()
			local t,n = lib.GetAura({"ab"})
			if n>=3 and lib.SpellCasting("ab") then
				return nil
			elseif n>=2 and lib.GetAura({"am"})>0 and lib.SpellCasting("ab") then
				return nil
			end
			return lib.SimpleCDCheck("ab")
		end,
		["am"] = function()
			if lib.GetAura({"am"})>0 and select(2,lib.GetAura({"ab"}))>=2 then
				return lib.SimpleCDCheck("am")
			end
			return nil
		end,
		["aba"] = function()
			if select(2,lib.GetAura({"ab"}))>=3 then
				return lib.SimpleCDCheck("aba")
			end
			return nil
		end,
		["ma"] = function()
			if lib.GetAura({"ma"})<3 then
				return lib.SimpleCDCheck("ma")
			end
			return nil
		end,
	}
	
	lib.rangecheck=function()
		if lib.inrange("ab") then
			lib.bdcolor(Heddframe.bd,nil)
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	cfg.spellcaster=true
	return true
end